import { makeDecorator } from '@storybook/addons';
import { triggerScreenshot } from './trigger-screenshot';
// NOTE:
// `makeDecorator` is only available with @storybook/addons@^5.0.0 .
const withScreenshotDecorator = makeDecorator &&
    makeDecorator({
        name: 'withScreenshot',
        parameterName: 'screenshot',
        skipIfNoParametersOrOptions: false,
        allowDeprecatedUsage: true,
        wrapper: (getStory, context, { parameters, options }) => {
            if (typeof process !== 'undefined' && (process === null || process === void 0 ? void 0 : process.env.JEST_WORKER_ID) !== undefined) {
                return getStory(context);
            }
            const screenshotOptions = parameters || options;
            triggerScreenshot(screenshotOptions, context);
            return getStory(context);
        },
    });
function withScreenshotLegacy(screenshotOptions = {}) {
    return (storyFn, ctx) => {
        const wrapperWithContext = (context) => {
            triggerScreenshot(screenshotOptions, context);
            return storyFn(context);
        };
        if (ctx) {
            return wrapperWithContext(ctx);
        }
        return (context) => wrapperWithContext(context);
    };
}
const withScreenshot = (withScreenshotDecorator || withScreenshotLegacy);
export { withScreenshot };
