"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withScreenshot = void 0;
const addons_1 = require("@storybook/addons");
const trigger_screenshot_1 = require("./trigger-screenshot");
// NOTE:
// `makeDecorator` is only available with @storybook/addons@^5.0.0 .
const withScreenshotDecorator = addons_1.makeDecorator &&
    (0, addons_1.makeDecorator)({
        name: 'withScreenshot',
        parameterName: 'screenshot',
        skipIfNoParametersOrOptions: false,
        allowDeprecatedUsage: true,
        wrapper: (getStory, context, { parameters, options }) => {
            if (typeof process !== 'undefined' && (process === null || process === void 0 ? void 0 : process.env.JEST_WORKER_ID) !== undefined) {
                return getStory(context);
            }
            const screenshotOptions = parameters || options;
            (0, trigger_screenshot_1.triggerScreenshot)(screenshotOptions, context);
            return getStory(context);
        },
    });
function withScreenshotLegacy(screenshotOptions = {}) {
    return (storyFn, ctx) => {
        const wrapperWithContext = (context) => {
            (0, trigger_screenshot_1.triggerScreenshot)(screenshotOptions, context);
            return storyFn(context);
        };
        if (ctx) {
            return wrapperWithContext(ctx);
        }
        return (context) => wrapperWithContext(context);
    };
}
const withScreenshot = (withScreenshotDecorator || withScreenshotLegacy);
exports.withScreenshot = withScreenshot;
