"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvalidCurrentStoryStateError = exports.ScreenshotTimeoutError = void 0;
class ScreenshotTimeoutError extends Error {
    constructor(msec, target) {
        super();
        this.name = 'ScreenshotTimeoutError';
        this.message = `Screenshot timeout exceeded. 'capture' function is not triggered in ${msec} ms. Target story: ${target.kind}/${target.story}`;
    }
}
exports.ScreenshotTimeoutError = ScreenshotTimeoutError;
class InvalidCurrentStoryStateError extends Error {
    constructor() {
        super();
        this.name = 'InvalidCurrentStoryStateError';
        this.message = 'Fail to screenshot. The current story is not set.';
    }
}
exports.InvalidCurrentStoryStateError = InvalidCurrentStoryStateError;
