"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileSystem = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const mkdirp = __importStar(require("mkdirp"));
const sanitize_filename_1 = __importDefault(require("sanitize-filename"));
class FileSystem {
    constructor(opt) {
        this.opt = opt;
    }
    /**
     *
     * Save captured buffer as a PNG image.
     *
     * @param kind - Story kind
     * @param story - Name of this story
     * @param suffix - File name suffix
     * @param buffer - PNG image buffer to save
     * @returns Absolute file path
     *
     **/
    save(kind, story, suffix, buffer) {
        const name = this.opt.flat
            ? (0, sanitize_filename_1.default)((kind + '_' + story).replace(/\//g, '_'))
            : kind
                .split('/')
                .map(k => (0, sanitize_filename_1.default)(k))
                .join('/') +
                '/' +
                (0, sanitize_filename_1.default)(story);
        const filePath = path_1.default.join(this.opt.outDir, name + (suffix.length ? `_${suffix.join('_')}` : '') + '.png');
        return new Promise((resolve, reject) => {
            mkdirp.sync(path_1.default.dirname(filePath));
            fs_1.default.writeFile(filePath, buffer, err => {
                if (err)
                    reject(err);
                resolve(filePath);
            });
        });
    }
}
exports.FileSystem = FileSystem;
