import { Story } from 'storycrawler';
import { CapturingBrowser } from './capturing-browser';
import { FileSystem } from './file';
import { Logger } from './logger';
/**
 *
 * Executor to capture all stories.
 *
 **/
export interface ScreenshotService {
    /**
     *
     * Run capturing procedure.
     *
     * @returns The number of captured images
     **/
    execute(): Promise<number>;
}
/**
 *
 * Parameters for {@link createScreenshotService}.
 *
 **/
export type ScreenshotServiceOptions = {
    logger: Logger;
    workers: CapturingBrowser[];
    fileSystem: FileSystem;
    stories: Story[];
};
/**
 *
 * Create an instance of {@link ScreenshotService}.
 *
 * @param options - {@link ScreenshotServiceOptions}
 * @returns A `ScreenshotService` instance
 *
 **/
export declare function createScreenshotService({ fileSystem, logger, stories, workers, }: ScreenshotServiceOptions): ScreenshotService;
